﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Lovec
{
    public partial class Form1 : Form
    {
        int totalTahy = 0;
        Multiplayer multi;
        Map m;
        int scale = 25;
        int offset = 50;
        public Form1()
        {
            /*
            XX............XX..XX 10
            XX..XX..XXXX..XX..XX
            XX......XXXX......XX
            XX..XX..XXXX..XX..XX
            XX..XX..XXXX..XX++XX
            XX..XXXXXXXXXXXXXXXX
            XX......XXXX10....XX
            XX..XX..XXXXXXXX..XX
            XX..XX..XXXX..XX..XX
            XX................XX 10
            */
            InitializeComponent();
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.Filter = "Map Files (.map)|*.map|All Files (*.*)|*.*";
            openFileDialog1.FilterIndex = 0;

            // Call the ShowDialog method to show the dialog box.
            var userClickedOK = openFileDialog1.ShowDialog();

            // Process input if the user clicked OK.
            if (userClickedOK == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader sr = new StreamReader(openFileDialog1.FileName);
                var result = sr.ReadToEnd();
                m = new Map(result, false);
                panel1.Invalidate();

                totalTahy = m.TotalTahy;
            }

        }
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (m == null)
                return false;

            if (!(m.rounds > 0))
                return false;
            
            if (keyData == Keys.L || keyData == Keys.Left)
            {
                if (m.Multiplayer)
                {
                    if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveLeft())
                        return true;
                    multi.Move("L");
                    m = multi.map;
                    panel1.Invalidate();
                    return true;
                }
                m[m.OurPlayer.X, m.OurPlayer.Y].MoveLeft(); m.rounds--;
                panel1.Invalidate(); if (m.Multiplayer)
                    m.jsemNaRade = false;
                return true; 
            }
            if (keyData == Keys.P || keyData == Keys.Right)
            {
                if (m.Multiplayer)
                {
                    if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveRight())
                        return true;
                    multi.Move("P");
                    m = multi.map;
                    panel1.Invalidate();
                    return true;
                }
                m[m.OurPlayer.X, m.OurPlayer.Y].MoveRight(); m.rounds--;
                panel1.Invalidate(); if (m.Multiplayer)
                    m.jsemNaRade = false;
                return true;
            }
            if (keyData == Keys.N || keyData == Keys.Up)
            {
                if (m.Multiplayer)
                {
                    if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveUp())
                        return true;
                    multi.Move("N");
                    m = multi.map;
                    panel1.Invalidate();
                    return true;
                }
                m[m.OurPlayer.X, m.OurPlayer.Y].MoveUp();
                m.rounds--;
                panel1.Invalidate(); if (m.Multiplayer)
                    m.jsemNaRade = false;
                return true;
            } if (keyData == Keys.D || keyData == Keys.Down)
            {
                if (m.Multiplayer)
                {
                    if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveDown())
                        return true;
                    multi.Move("D");
                    m = multi.map;
                    panel1.Invalidate();
                    return true;
                }
                m[m.OurPlayer.X, m.OurPlayer.Y].MoveDown(); m.rounds--;
                panel1.Invalidate(); if (m.Multiplayer)
                    m.jsemNaRade = false;
                return true;
            }

            return base.ProcessCmdKey(ref msg, keyData);
        }
        private void panel1_Paint(object sender, PaintEventArgs e) //drawing
        {
            if (m == null) //POKUD NEBYLO INICALIZOVANO
                return;

            this.Text = m.MultiplayerID.ToString();
            e.Graphics.DrawString("Rounds left: " + m.rounds.ToString() + " of " + totalTahy + " rounds   Score: " + m.OurPoints, new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(0, 0));
                 
            for (int x = 0; x < m.Width; x++)
            {
                for (int y = 0; y < m.Height; y++)
                { //PRO KAŽDY BLOK NAKRES
                    Brush b = Brushes.White;
                    if (m[x, y].Wall)
                        b = Brushes.Black;
                    if (m[x, y].OurBase)
                    {
                        b = Brushes.DarkRed;
                            e.Graphics.DrawString(m.OurPoints.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(x * scale, y * scale + offset));
                  
                    }
                    if (m[x, y].EnemyBase)
                    {
                        b = Brushes.ForestGreen;
                        e.Graphics.DrawString(m.EnemyPoints.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(x * scale, y * scale + offset));
                  
                    }
                    if (m[x, y].tresure)
                    {
                        b = Brushes.LightCyan;
                    }
                    if (m[x, y].EnemyPlayer)
                    {
                        b = Brushes.Red;
                        if (m.EnemyTreasure)
                            e.Graphics.DrawString(m.EnemyTreasureValue.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.White, new PointF(x * scale, y * scale + offset));
                  
                    } if (m[x, y].OurPlayer)
                    {
                        b = Brushes.LightGreen;
                        if(m.OurTreasure)
                            e.Graphics.DrawString(m.OurTreasureValue.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(x * scale, y * scale + offset));
                  
                    }
                    e.Graphics.FillRectangle(b, x * scale, y * scale + offset, scale, scale);
                    if (m[x, y].tresure)
                    {
                        e.Graphics.DrawString(m[x, y].TresureValue.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(x * scale, y * scale + offset));
                    }
                    if (m[x, y].EnemyPlayer)
                    {
                        b = Brushes.Red;
                        if (m.EnemyTreasure)
                            e.Graphics.DrawString(m.EnemyTreasureValue.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.White, new PointF(x * scale, y * scale + offset));
                  
                    } if (m[x, y].OurPlayer)
                    {
                        b = Brushes.LightGreen;
                        if (m.OurTreasure)
                            e.Graphics.DrawString(m.OurTreasureValue.ToString(), new System.Drawing.Font("Arial", scale / 2), Brushes.Red, new PointF(x * scale, y * scale + offset));

                    }
                }
            }
            
        }

        private void button2_Click(object sender, EventArgs e) //START MULTIPLAYER
        {
            multi = new Multiplayer(textBox1.Text);
            m = multi.map;
            totalTahy = m.TotalTahy;
            panel1.Invalidate();
        }

        private void button3_Click(object sender, EventArgs e) //HELP MENU
        {
            MessageBox.Show("ŠIPKY nebo to blbé L P N D je pohyb "+System.Environment.NewLine+"Světle zelený je hráč, čísla jsou poklady, tmavě zelená je základna");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (m == null) //POKUD NEBYLO INICALIZOVANO
                return;

            if (m.Multiplayer)
            {
                if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveDown())
                    return;
                multi.Move("D");
                m = multi.map;
                panel1.Invalidate();
                return;
            }
            m[m.OurPlayer.X, m.OurPlayer.Y].MoveDown(); m.rounds--;
            panel1.Invalidate(); 
            return;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (m == null) //POKUD NEBYLO INICALIZOVANO
                return;
            if (m.Multiplayer)
            {
                if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveRight())
                    return;
                multi.Move("P");
                m = multi.map;
                panel1.Invalidate();
                return;
            }
            m[m.OurPlayer.X, m.OurPlayer.Y].MoveRight(); m.rounds--;
            panel1.Invalidate(); if (m.Multiplayer)
                m.jsemNaRade = false;
            return;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //UP
            if (m == null) //POKUD NEBYLO INICALIZOVANO
                return;

            if (m.Multiplayer)
            {
                if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveUp())
                    return;
                multi.Move("N");
                m = multi.map;
                panel1.Invalidate();
                return;
            }
            m[m.OurPlayer.X, m.OurPlayer.Y].MoveUp();
            m.rounds--;
            panel1.Invalidate(); if (m.Multiplayer)
                m.jsemNaRade = false;
            return;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (m.Multiplayer)
            {
                if (!m[m.OurPlayer.X, m.OurPlayer.Y].MoveLeft())
                    return;
                multi.Move("L");
                m = multi.map;
                panel1.Invalidate();
                return;
            }
            m[m.OurPlayer.X, m.OurPlayer.Y].MoveLeft(); m.rounds--;
            panel1.Invalidate();

        }
    }
}
