﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Lovec
{

    public class MyDisplay : Panel
    {
        public MyDisplay()
        {
            this.DoubleBuffered = true;

            // or

            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
            UpdateStyles();
        }
    }
//    300
//....................
//..XXXXXXXXXXXXXXXX..
//..XX............XX..
//..XX..XXXXXXXX..XX..
//..XX..XX50XXXX..XX..
//..XX..XX10..XX..XX..
//..XX..XXXX..XX..XX..
//..XX........XX..XX..
//..XXXXXXXXXXXX..XX..
//................XX++
//SLOUPCE/RADEK/AKTUAL POKLAD/SCORE
    // 1 - 10
    //XX - ZED
    //.. - Volno
    //00 - poklad
    //++ - zakladna
    //-- - enym base
    public class Multiplayer //MULTIPLAYER SESSION
    {
        int multiplayerId = 0;
        public Map map;
        public string ip;
        WebClient w = new WebClient();
        public Multiplayer(string ip)
        {
            this.ip = ip;
            var s = w.DownloadString("http://"+ip+"/start");
            map = new Map(s, true);
            multiplayerId = map.MultiplayerID;
        }
        public void Move(string move)
        {
            var s = w.DownloadString("http://" + ip + "/tah?id=" + multiplayerId + "&pohyb=" + move);
            map = new Map(s, true);
        }
    }


    public class Map
    {
        public int TotalTahy;
        public int Width;
        public int Height;
        public List<MapObject[]> lines;
        public Point OurPlayer;
        public Point EnemyPlayer;
        public int OurPoints = 0;
        public int MultiplayerID = 0;
        public int EnemyPoints = 0;
        public bool OurTreasure = false;
        public int OurTreasureValue = 0;
        public bool EnemyTreasure = false;
        public int EnemyTreasureValue = 0;
        public bool jsemNaRade = true;
        public bool Multiplayer = false;
        public bool Failed = false;
        public bool AIgame = false;
        public int rounds = 0;
        public Map(string s, bool multiplayer) //INICIALIZACE A NAČITANI MAPY Z STRINGU
        {
            
            if(string.IsNullOrEmpty(s))
            {
                Failed = true;
                return;
            }

            int multiplayerOffset = 0;
            if (multiplayer)
                multiplayerOffset = -3;
            int multiplayerOffset2 = 0;
            if (multiplayer)
                multiplayerOffset2 = 1;
            var splitted = s.Split(new string[] { Environment.NewLine }, StringSplitOptions.None);

            if (splitted.Length == 2)
            {
                MessageBox.Show(s);
                return;
            }
            var success = int.TryParse(splitted[multiplayerOffset2], out rounds);
            TotalTahy = rounds;
            if (!success)
            {
                Failed = true;
                return;
            }
            lines = new List<MapObject[]>(); 
            for (int i = 1 + multiplayerOffset2; i < splitted.Length + multiplayerOffset; i++)
            {
                if (string.IsNullOrWhiteSpace(splitted[i]))
                    continue;
                
                MapObject[] mp = new MapObject[splitted[i].Length / 2];

                for (int x = 0; x < splitted[i].Length; x+=2)
                {
                    if (splitted[i][x] == '.')
                    {
                        mp[x/2] = new MapObject() { parent = this};
                    }
                    else if (splitted[i][x] == 'x' || splitted[i][x] == 'X')
                    {
                        mp[x/2] = new MapObject() { parent = this, Wall= true};
                    }
                    else if (splitted[i][x] == '+')
                    {
                        mp[x/2] = new MapObject() { parent = this, OurBase = true, OurPlayer =true};
                        OurPlayer = new Point(x / 2, lines.Count);
                    }
                    else if (splitted[i][x] == '-')
                    {
                        mp[x/2] = new MapObject() { parent = this, EnemyBase = true, EnemyPlayer = true};
                        EnemyPlayer = new Point(x / 2, lines.Count);
                        AIgame = true;
                        multiplayerOffset--;
                    }
                    else
                    {
                        string tresureNum = new string(new char[] { splitted[i][x], splitted[i][x+1] });
                        var tresureNumInt = 0;
                        var success2 = int.TryParse(tresureNum, out tresureNumInt);
                        if (!success2)
                        { Failed = true; return; }
                        mp[x / 2] = new MapObject() { parent = this, tresure = true, TresureValue = tresureNumInt};
                    }
                }
                lines.Add(mp);
            }
            if (multiplayer) {
                Multiplayer = true;
                MultiplayerID = int.Parse(splitted[0]);
                this[OurPlayer.X, OurPlayer.Y].OurPlayer = false;
                
                var lastLine = splitted[splitted.Length-3];
                var splitted2 = lastLine.Split(new string[] { " " }, StringSplitOptions.None);
                OurPlayer = new Point(int.Parse(splitted2[0]) - 1, int.Parse(splitted2[1]) - 1);
                this[OurPlayer.X, OurPlayer.Y].OurPlayer = true;
                var poklad = int.Parse(splitted2[2]);
                if (poklad != 0)
                {
                    OurTreasureValue = poklad;
                    OurTreasure = true;
                }
                OurPoints = int.Parse(splitted2[3]);

                if (AIgame)
                {
                    this[EnemyPlayer.X, EnemyPlayer.Y].EnemyPlayer = false;

                    lastLine = splitted[splitted.Length - 4];
                    splitted2 = lastLine.Split(new string[] { " " }, StringSplitOptions.None);
                    EnemyPlayer = new Point(int.Parse(splitted2[0]) - 1, int.Parse(splitted2[1]) - 1);
                    this[EnemyPlayer.X, EnemyPlayer.Y].EnemyPlayer = true;
                    poklad = int.Parse(splitted2[2]);
                    if (poklad != 0)
                    {
                        EnemyTreasureValue = poklad;
                        EnemyTreasure = true;
                    }
                    EnemyPoints = int.Parse(splitted2[3]);
                }
            //SLOUPCE/RADEK/AKTUAL POKLAD/SCORE
            }
            Width = lines.Count;
            Height = lines[0].Length;
        }
            
        public MapObject this[int x, int y]
        {
            get
            {
                return lines[y][x];
            }
            set
            {
                lines[y][x] = value;
            }
        }
    }
    public class MapObject
    {
        public Map parent;
        public bool OurPlayer = false;
        public bool EnemyPlayer = false;
        public bool tresure = false;
        public int TresureValue = 0;
        public bool OurBase = false;
        public bool EnemyBase = false;
        public bool Wall = false;

        public bool isWithin(int x, int y)
        {
            if (x > -1 && y > -1 && x < parent.Width && y < parent.Height)
                return true;
            return false;
        }
        public bool MoveUp()
        {
            var original = parent.OurPlayer;
            if (parent.Multiplayer)
                original = parent.EnemyPlayer;
            return Move(new Point(original.X, original.Y - 1));
        }
        public bool MoveDown()
        {
            var original = parent.OurPlayer;
            if (parent.Multiplayer)
                original = parent.EnemyPlayer;
            return Move(new Point(original.X, original.Y + 1));
        }
        public bool MoveLeft()
        {
            var original = parent.OurPlayer;
            if (parent.Multiplayer)
                original = parent.EnemyPlayer;
            return Move(new Point(original.X-1, original.Y));
        }
        public bool MoveRight()
        {
            var original = parent.OurPlayer;
            if (parent.Multiplayer)
                original = parent.EnemyPlayer;
            return Move(new Point(original.X+1, original.Y));
        }
        public bool MoveMP(Point Dest)
        {
            var original = parent.EnemyPlayer;
            var desiredPoint = Dest;
            if (!isWithin(desiredPoint.X, desiredPoint.Y))
                return false;
            var wantInto = parent[desiredPoint.X, desiredPoint.Y];
            if (wantInto.Wall || wantInto.OurPlayer || wantInto.EnemyBase)
                return false;

            return true;
        }
        public bool Move(Point Dest)
        {
            if (parent.Multiplayer)
                return MoveMP(Dest);
            var original = parent.OurPlayer;
            var desiredPoint = Dest;
            if (!isWithin(desiredPoint.X, desiredPoint.Y))
                return false;
            var wantInto = parent[desiredPoint.X, desiredPoint.Y];
            if (wantInto.Wall || wantInto.EnemyPlayer || wantInto.EnemyBase)
                return false;

            wantInto.OurPlayer = true;
            parent[original.X, original.Y].OurPlayer = false;
            parent.OurPlayer = desiredPoint;
            if (wantInto.tresure && !parent.OurTreasure) //PICK  UP TREASURE
            {
                parent.OurTreasure = true;
                parent.OurTreasureValue = wantInto.TresureValue;
                wantInto.tresure = false;
            }
            if (wantInto.OurBase && parent.OurTreasure) //DROP OFF TREASURE
            {
                parent.OurTreasure = false;
                parent.OurPoints += parent.OurTreasureValue;
            }
            return true;
        }
    }
    
}
